<?php
session_start();
// 文档名称
define('TITLE', 'WebSocket+API接口文档即时生成器');
// 登陆密码
define('PWD', '123456');

// 退出
if (isset($_GET['status']) && $_GET['status'] == 'out') {
    $_SESSION['websocket_word'] = '';
    echo '退出成功!';exit;
// 登陆
} else if (isset($_GET['status']) && $_GET['status'] == 'login') {
    if ($_POST['pwd'] == PWD) {
        $_SESSION['websocket_word'] = '1';
        echo 1;
    } else {
        echo 2;
    }
    exit;
// 参数转json
} else if (isset($_GET['status']) && $_GET['status'] == 'ajax_param') {
    $file = __DIR__."/param.php";
    $myfile = fopen($file, "w") or die('NO');
    fwrite($myfile, "<?php \r\n".$_POST['param']);
    fclose($myfile);
    $array = require_once $file;

    if (isset($_POST['class'])) {
        $data = [];
        $data['action'] = $_POST['action'];
        $data['data'] = $array['param'];
        echo json_encode($data);
    } else {
        echo json_encode($array);
    }
    exit;
}

function is_https() {
    if ( !empty($_SERVER['HTTPS']) && strtolower($_SERVER['HTTPS']) !== 'off') {
        return true;
    } elseif ( isset($_SERVER['HTTP_X_FORWARDED_PROTO']) && $_SERVER['HTTP_X_FORWARDED_PROTO'] === 'https' ) {
        return true;
    } elseif ( !empty($_SERVER['HTTP_FRONT_END_HTTPS']) && strtolower($_SERVER['HTTP_FRONT_END_HTTPS']) !== 'off') {
        return true;
    }
    return false;
}
// 接口跟地址
$url = dirname( $_SERVER['HTTP_HOST'].str_replace('index.php','', $_SERVER['REQUEST_URI'])).'/index.php/';
if (is_https()) {
    $url = 'https://'.$url;
} else {
    $url = 'http://'.$url;
}

// 长连接接口
$api = [
    [
        'name' => 'shop/insert',
        'title' => '商品新增',
        'word' => '未编写'
    ],
    [
        'name' => 'shop/update',
        'title' => '商品修改',
'word' => "return [
    // 请求参数
    'param' => [
    ],
    // 返回值
    'return' => [
        // 状态码囊括
        'action' => [
            'heartbeat_ok' => '心跳正常', 
            'error' => '接口错误',
        ]
    ]
];"
    ],
];
// 长连接返回值
$code = [
    [
        'name' => 'Error',
        'title' => '请求错误',
        'file' => 'Error/index',// 唯一标识
        'word' => '未编写'
    ],
    [
        'name' => 'Success',
        'title' => '请求成功',
        'file' => 'Success/index',// 唯一标识
'word' => "return [
    // 返回值
    'return' => [
        // data部分返回值说明
        'data' => [
        ]
    ]
];"
    ],
];
// 外部接口
$http = [
    [
        'name' => 'shop/insert',
        'title' => '商品新增',
        'word' => '未编写'
    ],
    [
        'name' => 'shop/update',
        'title' => '商品修改',
'word' => "return [
    // 请求头
    'header' => [
        'method' => 'POST', // 请求类型
        'code' => 'utf-8', // 内容编码
        'content-type' => 'application/x-www-form-urlencoded', // 数据类型
        // 其余自定义header
    ],
    // 请求参数
    'param' => [
        // 参考格式
        'phone' => '15992431677', // 手机号 string(32) 默认null 不为空
        'password' => '123456', // 密码 string(32) 默认null 不为空
    ],
    // 返回值
    'return' => [
        // 状态码囊括
        'code' => [
            '200' => '请求正常', 
            '301' => '错误提示', 
            '500' => '服务器错误',
        ],
        // data部分返回值说明
        'data' => [
        ]
    ]
];"
    ]
];
// 获取配置
$config = [
    'websocket_crt_path' => false, // WSS
    'websocket_port' => 9501, // 端口
    'websocket_aes_key' => '', //密钥
    'websocket_aes_type' => '', //加密方式
    'websocket_aes_iv' => '', //iv向量
];
?>

<!DOCTYPE html>
<html>
    <head>
        <meta charset="utf-8">
        <title><?php echo TITLE;?></title>
        <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
        <meta name="renderer" content="webkit">

        <link href="css/font-awesome.min.css" rel="stylesheet" type="text/css">
        <link rel="stylesheet" href="js/CodeMirror/codemirror.css">
        <link href="css/page.css?v=1.0.4" rel="stylesheet" type="text/css">
        <link href="css/main.css?v=1.0.4" rel="stylesheet" type="text/css">

        <script src="https://www.jq22.com/jquery/jquery-2.1.1.js"></script>
        <script src="js/CodeMirror/codemirror.js"></script>
        <script src="js/CodeMirror/javascript.js"></script>

        <style>
        
        </style>

    </head>

    <body>

<?php if (!empty($_SESSION['websocket_word'])) { ?>
<div id="j_taskcenter" class="main">
 <div class="j_mainscroll mCus-mh100 scrollwrapper mCustomScrollbar _mCS_11 mCS_no_scrollbar">
  <div class="mCustomScrollBox mCS-darkblue mCSB_vertical mCSB_inside" id="mCSB_11" tabindex="0">
   <div dir="ltr" style="position:relative; top:0; left:0;" class="mCSB_container mCS_y_hidden mCS_no_scrollbar_y" id="mCSB_11_container">
    <div class="main-bd sidebar-in j_sidebarPren">
     <div class="table-tray scrollwrapper">
      <div class="main-content">


<div id="main" class="fix-sidebar">
    <div class="sidebar" style=" top: 0;">
        <div class="sidebar-inner">
            <div class="list">
                <a class="become-backer">文档列表</a>
                <a class="become-backer">已完成：<font color="red" id="yes">-</font></a><br/>

                <a class="become-backer" id="tab">切换列表-接口地址</a>
                <a class="become-backer">待完成：<font color="red" id="no">-</font></a><br/>

                <a class="become-backer" href="message_center.php" target="_blank">
                    消息中心
                </a>
                <a class="become-backer">已对接：<font color="red" id="ok">-</font></a>

                <a class="become-backer" id="out">退出</a>
                <ul class="menu-root">
                    <li>
                        <a class="sidebar-link current">WebSocket 接口文档</a>
                        <ul class="menu-sub">
                            <li> <a class="section-link" href="#api-a">WebSocket地址</a></li>
                            <li> <a class="section-link" href="#api-b">握手请求验签</a></li>
                            <li> <a class="section-link" href="#api-c">数据发包格式</a></li>
                            <li> <a class="section-link" href="#api-d">数据发包加密</a></li>
                            
                            <?php $num = 0;?>
                            <?php foreach( $api as $k=>$v) { ?>
                            <?php 
                                $num++; 
                                $md5 = md5(strtolower($v['name'])).'.api';                                  
                                $path1 = __DIR__."/php/check_1/";
                                $path2 = __DIR__."/php/check_2/";
                                $color = '';
                                if (file_exists($path2.$md5)) {
                                    $color = "#03a9f4";
                                } else if (file_exists($path1.$md5)) {
                                    $color = "#db0096";
                                } if ($v['word'] == '未编写') {
                                   $color = "red";
                                }
                            ?>
                            <li> <a class="section-link" id="api<?php echo $num;?>" href="#api-<?php echo $num;?>" style="color:<?php echo $color;?>"><?php echo $num.'、<span class="hide">'.$v['name'].'：</span>'.$v['title'];?></a></li>
                            <?php } ?>
                        </ul>
                    </li>
                    <li>
                        <a class="sidebar-link current">服务端Callback 接口文档</a>
                        <ul class="menu-sub">
                            <li> <a class="section-link" href="#code-a">返回值格式</a></li>
                            
                            <?php $num = 0;?>
                            <?php foreach( $code as $k=>$v) { ?>
                            <?php 
                                $num++; 
                                $md5 = md5(strtolower($v['file'])).'.log';                                  
                                $path1 = __DIR__."/php/check_1/";
                                $path2 = __DIR__."/php/check_2/";
                                $color = '';
                                if (file_exists($path2.$md5)) {
                                    $color = "#03a9f4";
                                } else if (file_exists($path1.$md5)) {
                                    $color = "#db0096";
                                } if ($v['word'] == '未编写') {
                                    $color = "red";
                                }
                            ?>
                            <li> <a class="section-link" id="code<?php echo $num;?>" href="#code-<?php echo $num;?>" style="color:<?php echo $color;?>"><?php echo $num.'、<span class="hide">'.$v['name'].'：</span>'.$v['title'];?></a></li>
                            <?php } ?>
                        </ul>
                    </li>

                    <li>
                        <a class="sidebar-link current">外部HTTP 接口文档</a>
                        <ul class="menu-sub">
                            <li> <a class="section-link" href="#http-a">接口地址</a></li>
                            <li> <a class="section-link" href="#http-b">请求格式</a></li>
                            
                            <?php $num = 0;?>
                            <?php foreach( $http as $k=>$v) { ?>
                            <?php 
                                $num++; 
                                $md5 = md5(strtolower($v['name'])).'.http';                                  
                                $path1 = __DIR__."/php/check_1/";
                                $path2 = __DIR__."/php/check_2/";
                                $color = '';
                                if (file_exists($path2.$md5)) {
                                    $color = "#03a9f4";
                                } else if (file_exists($path1.$md5)) {
                                    $color = "#db0096";
                                } if ($v['word'] == '未编写') {
                                   $color = "red";
                                }
                            ?>
                            <li> <a class="section-link" id="http<?php echo $num;?>" href="#http-<?php echo $num;?>" style="color:<?php echo $color;?>"><?php echo $num.'、<span class="hide">'.$v['name'].'：</span>'.$v['title'];?></a></li>
                            <?php } ?>
                        </ul>
                    </li>

                </ul>
            </div>
        </div>
    </div>

    <div class="content guide with-sidebar index-guide">
        <h1><?php echo TITLE;?></h1>
        <p>该文档随着代码内部，自动更新。</p>

        <h1>WebSocket 接口文档</h1>

        <h2 id="api-a">WebSocket地址</h2>
        <div>
            <?php 
            $ws = '';
            $server = $_SERVER['SERVER_NAME'];
            $ip = gethostbyname($server);
            if ($config['websocket_crt_path']){
                $ws = 'wss://'.$server.':'.$config['websocket_port'];
            } else {
                $ws = 'ws://'.$ip.':'.$config['websocket_port'];
            }
            echo '<code id="ws">'.$ws.'</code>';
            ?>
        </div>
        <h2 id="api-b">握手请求验签</h2>
        <div>
            需要在WebSocket地址中添加5个参数，以<code>GET</code>的方式打开WebSocket。
            <br/><br/>
            ip：客户端IP<br/>
            open_time：打开时间戳<br/>
            device_number：设备号<br/>
            source：来源标识<br/>
            sign：加密签名<br/>
            <br/><br/>
            其中加密签名的生成方式为:<br/>
            <code> md5(base64_encode(md5(ip + open_time + device_number + source))) </code><br/><br/>
            
            最终可能生成如下WS地址：<br/>
            <div id="socket_url"><?php echo $ws;?>?ip=127.0.0.1&open_time=1587016473&device_number=70:72:3c:b9:17:27&source=android&sign=8346a17a6450cf18b9314c48ab46341b</div>
        </div>
        <h2 id="api-c">数据发包格式</h2>
        <div>
<textarea id="api_c">
{
    "action":"接口名称",
    "data":{} // 请求参数
}    
</textarea>
        </div>
        <h2 id="api-d">数据发包加密</h2>
        <div>
            <?php
                if (empty($config['websocket_aes_key'])) {
                    echo '不启用数据加解密传输。';
                } else {
                    echo '加密方式：'.$config['websocket_aes_type'].'<br/>';
                    echo '密钥：'.$config['websocket_aes_key'].'<br/>';
                    echo 'iv向量：'.$config['websocket_aes_iv'].'<br/>';
                }
            ?>
        </div>
        
        <?php $num = 0; $yes=0; $no=0;?>
        <?php foreach( $api as $k=>$v) { ?>
        <?php $num++;?>
        <h2 id="api-<?php echo $num;?>"><?php echo $k.'、'.$v['title'];?></h2>
        <?php 
            if ($val['word'] == '未编写') {
                $no++;
            } else {
                $yes++;
            }
        ?>
        <p>
            action事件：<code id="action-<?php echo $num;?>"><?php echo $v['name'];?></code>
            <button class="api_copy" onclick="api_copy('<?php echo $v['name'];?>', this)">复制</button>
            <button class="check_1" onclick="check_1('api<?php echo $num;?>', '<?php echo $v['file'];?>', this)">标记：进行中</button>
            <button class="check_2" onclick="check_2('api<?php echo $num;?>', '<?php echo $v['file'];?>', this)">标记：已对接</button>
            <button class="ajax_socket_btn" data-id="action-<?php echo $num;?>">调试事件</button>
        </p>
        <textarea id="api_<?php echo $num;?>"><?php echo $v['word'];?></textarea>    
        <?php } ?>

        <br/>
        <br/>
        <br/>
        <h1>服务端Callback 接口文档</h1>
        <h2 id="code-a">返回值格式</h2>
        <div>
<textarea id="code_a">
{
    "action":"回调事件名称",
    "msg":"说明",
    "data":{} // 返回参数
}    
</textarea>
        </div>
        
        <?php $num = 0;?>
        <?php foreach( $code as $k=>$v) { ?>
        <?php $num++;?>
        <h2 id="code-<?php echo $num;?>"><?php echo $k.'、'.$v['title'];?></h2>
        <?php 
            if ($val['word'] == '未编写') {
                $no++;
            } else {
                $yes++;
            }
        ?>
        <p>
            action回调事件：<code id="code-<?php echo $num;?>"><?php echo $v['name'];?></code>
            <button class="api_copy" onclick="api_copy('<?php echo $v['name'];?>', this)">复制</button>
            <button class="check_1" onclick="check_1('code<?php echo $num;?>', '<?php echo $v['file'];?>', this)">标记：进行中</button>
            <button class="check_2" onclick="check_2('code<?php echo $num;?>', '<?php echo $v['file'];?>', this)">标记：已对接</button>
        </p>
        <textarea id="code_<?php echo $num;?>"><?php echo $v['word'];?></textarea>    
        <?php } ?>


        <br/>
        <br/>
        <br/>
        <h1>外部HTTP 接口文档</h1>

        <h2 id="http-a">请求地址</h2>
        <div>
            <?php 
            $server = $_SERVER['SERVER_NAME'];
            if ($config['websocket_crt_path']){
                $url = 'https://'.$server.':'.$config['websocket_port'];
            } else {
                $url = 'http://'.$server.':'.$config['websocket_port'];
            }
            echo '<code id="api_root">'.$url.'</code>';
            ?>
        </div>

        <h2 id="http-b">请求格式</h2>
        <div>
            所有的请求都需要在CURL，<code>header</code>请求头中带入<code>api_key</code>密钥，该值为<code><?php echo $config['websocket_api_key'];?></code>
        </div>
        
        <?php $num = 0;?>
        <?php foreach( $http as $k=>$v) { ?>
        <?php $num++;?>
        <h2 id="http-<?php echo $num;?>"><?php echo ($k+1).'、'.$v['title'];?></h2>
        <?php 
            if ($val['word'] == '未编写') {
                $no++;
            } else {
                $yes++;
            }
        ?>
        <p>
            接口地址：<code id="https-<?php echo $num;?>"><?php echo $v['name'];?></code>
            <button class="api_copy" onclick="api_copy('<?php echo $v['name'];?>', this)">复制</button>
            <button class="check_1" onclick="check_1('http<?php echo $num;?>', '<?php echo $v['file'];?>', this)">标记：进行中</button>
            <button class="check_2" onclick="check_2('http<?php echo $num;?>', '<?php echo $v['file'];?>', this)">标记：已对接</button>
            <button class="ajax_api_btn" data-id="https-<?php echo $num;?>">调试接口</button>
        </p>
        <textarea id="http_<?php echo $num;?>"><?php echo $v['word'];?></textarea>    
        <?php } ?>
        

    </div>

</div>   


      </div>
     </div>
    </div>
   </div>
  </div>
 </div>
</div>

<!--复制文本框-->
<textarea id="inputBox" style="position: absolute;top: 0;left: 0;opacity: 0;z-index: -10;"></textarea>
<!--接口调试面板-->
<style>
.mask_div{position: fixed;right: 0;top: 0;z-index: 99999;background: #fff;border-left: 1px solid #ccc;width: 600px;height: 100%;overflow-y: auto;}
.mask_title{float: left;width: 100%;text-align: center;height: 50px;line-height: 50px;border-bottom: 1px solid #ccc;}
.mask_content, .mask_content2{float: left;padding: 10px;}
#close{position: absolute;right: 10px; color:#42b983;cursor: pointer;}
#close:hover{color:red}
</style>
<div class="mask_div">
    <div class="mask_title">WebSocket调试器</div>  
    <div class="mask_content2">
        <div class="zone_conn">
            <input type="text" class="form-control" style="float:left;" id="inp_url" value="" placeholder="连接的地址">
            <button type="button" id="btn_conn" class="btn btn-primary" style="float:left;margin-left:10px;margin-right:10px;" onclick="fun_initWebSocket();">连接</button>
            <button type="button" id="btn_close" class="btn btn-danger" style="float:left;" onclick="fun_close();">断开</button>
        </div>
        <div class="zone_send">
            <textarea id="inp_send" class="form-control" style="height:100px;" placeholder="发送的内容"></textarea>
            <br>
            <button type="button" id="btn_send" class="btn btn-info" onclick="fun_sendto();">发送</button>
        </div>
    </div>
    <div id="div_msgzone" class="panel panel-default" style="float: left;">
        <div class="panel-heading">消息窗口</div>
        <div id="div_msg" class="panel-body">
            
        </div>
    </div>
    <div class="mask_title">HTTP外部接口调试器</div>  
    <div class="mask_content" style="width: 90%;">

    </div>
</div>
<script>
// start websocket
// 打开websocket
var wsServer = $('#socket_url').html();
wsServer = wsServer.replace(/&amp;/g,"&");
var websocket = false;
$('#inp_url').val(wsServer);
err('注意：WebSocket调试器，暂不支持加密模式下的事件调试，开发阶段，请使用明文模式');
function fun_initWebSocket() {
    if (websocket) {
        alert('请先断开连接！');
        return false;
    }
    try {
        add('正在打开WebSocket');
		websocket = new WebSocket(wsServer);
        // 接收Socket断开时的消息通知
        websocket.onclose = function(evt) {
            err('WebSocket断开了...');
            websocket = false;
            $('#inp_send').val('');
        };
        // 接收Socket连接失败时的异常通知
        websocket.onerror = function(e){
            err('WebSocket连接打开失败...');
        };
        // 连接成功
        websocket.onopen = function (evt) {
            err('WebSocket连接成功...');
        };
        // 接收服务端广播的消息通知
        websocket.onmessage = function(evt){
            var obj = JSON.parse(evt.data); 
            // err('<b>服务端主动向你推送：</b>');
            err(evt.data);
        };
	} catch(e) {
        console.log(e);
	}
}
function fun_close() {
    if (websocket == false) {
        err('WebSocket已断开，请先连接...');
        return false;
    }
    websocket.close();
    websocket = false;
}
function fun_sendto() {
    if (websocket == false) {
        err('WebSocket已断开，请先连接...');
        return false;
    }
    var content = $('#inp_send').val();
    websocket.send(content);
    add(content);
}
$('.ajax_socket_btn').click(function() {
    var id = $(this).attr('data-id');
    var api_url = $('#'+id).html();
    
    var api_param = $(this).parent().next('textarea').val();
    var data = api_param.slice(7).replace(';', '');

    $.ajax({
        type: 'post',
        data:{
            param:api_param,
            action:api_url,
            class:1,
        },
        url: "index.php?status=ajax_param",
        success: function(data) {
            if (data == 'NO') {
                alert('/apiword/param.php 文件无写入权限，无法对param参数进行转换！');
            } else {
                $('#inp_send').val(data);
            }
        }
    });
});
// end websocket

function getNow(s) {
    return s < 10 ? '0' + s: s;
}
function add(des) {
    var myDate = new Date();
    var h=myDate.getHours();
    var m=myDate.getMinutes();
    var s=myDate.getSeconds();  
    var html = '<div style="margin-bottom:10px;position:relative;left:0px;"><div style="color:green">你 '+getNow(h)+':'+getNow(m)+":"+getNow(s)+'</div>'+des+'...</div>';
    $('#div_msg').append(html);
    $('#div_msg').scrollTop( $('#div_msg')[0].scrollHeight );
}
function err(des) {
    var myDate = new Date();
    var h=myDate.getHours();
    var m=myDate.getMinutes();
    var s=myDate.getSeconds();  
    var html = '<div style="margin-bottom:10px;position:relative;left:0px;"><div style="color:blue">服务器 '+getNow(h)+':'+getNow(m)+":"+getNow(s)+'</div>'+des+'</div>';
    $('#div_msg').append(html);
    $('#div_msg').scrollTop( $('#div_msg')[0].scrollHeight );
}


function api_copy(txt, _this) {
    var copyBox = document.getElementById('inputBox');
    copyBox.value = txt;
    copyBox.select();
    document.execCommand('copy');
    $(_this).html('Copy OK！');
    setTimeout(function () {
        $(_this).html('复制');
    }, 1200);
}
function check_1(id, url, _this) {
    $.ajax({
        type: 'post',
        data:{url:url},
        url: "php/check_1.php",
        success: function(data) {
            if (data == 'YES') {
                $(_this).html('标记成功！');
                setTimeout(function () {
                    $(_this).html('标记：进行中');
                }, 1200);

                var color = $('#'+id).css('color');
                if (color == 'rgb(219, 0, 150)') {
                    $('#'+id).css('color', '#34495e');
                } else {
                    $('#'+id).css('color', '#db0096');
                }
            } else {
                alert(data);
            }
        }
    });
}
function check_2(id, url, _this) {
    $.ajax({
        type: 'post',
        data:{url:url},
        url: "php/check_2.php",
        success: function(data) {
            if (data == 'YES') {
                $(_this).html('标记成功！');
                setTimeout(function () {
                    $(_this).html('标记：已对接');
                }, 1200);

                var color = $('#'+id).css('color');
                if (color == 'rgb(3, 169, 244)') {
                    $('#'+id).css('color', '#34495e');
                } else {
                    $('#'+id).css('color', '#03a9f4');
                }
            } else {
                alert(data);
            }
        }
    });
}

$('#yes').html(<?php echo $yes;?>);
$('#no').html(<?php echo $no;?>);

$('#close').click(function(){
    $('.mask_div').hide();
});
var editor;
$('.ajax_api_btn').click(function(){
    $('.mask_content').html('');
    var api_root = $('#api_root').html();
    var api_title = $(this).parent().prev('h2').html();
    $('.mask_content').append('<div>请求接口：'+api_title+'</div>');
    var id = $(this).attr('data-id');
    var api_url = $('#'+id).html();
    $('.mask_content').append('<div>请求地址：<span id="api_url">'+api_url+'</span></div>');
    var api_param = $(this).parent().next('textarea').val();
    var data = api_param.slice(7).replace(';', '');
    $.ajax({
        type: 'post',
        data:{param:api_param},
        url: "index.php?status=ajax_param",
        success: function(data) {
            if (data == 'NO') {
                alert('/apiword/param.php 文件无写入权限，无法对param参数进行转换！');
            } else {
                var a = eval('('+data+')');
                $('.mask_content').append('<div>请求类型：<span id="api_post">'+a.header.method+'</span></div>');
                $('.mask_content').append('<div>数据类型：<span id="api_type">'+a.header['content-type']+'</span></div>');
                $('.mask_content').append('<div>数据编码：<span id="api_code">'+a.header.code+'</span></div>');
                $('.mask_content').append('<div>请求数据：</div>');
                $('.mask_content').append('<textarea id="ajax_content">'+JSON.stringify(a.param, null, 4)+'</textarea>');
                var json = {lineNumbers: true,mode: "text/javascript",styleActiveLine: true,theme: 'material',lineWrapping: true};
                editor = CodeMirror.fromTextArea(document.getElementById("ajax_content"), json);
                editor.setSize('85%', '100%');

                $('.mask_content').append('<div>返回值对照表：</div>');
                $('.mask_content').append('<textarea id="ajax_code">'+JSON.stringify(a.return, null, 4)+'</textarea>');
                var json = {lineNumbers: true,mode: "text/javascript",styleActiveLine: true,theme: 'material',lineWrapping: true};
                CodeMirror.fromTextArea(document.getElementById("ajax_code"), json).setSize('85%', '100%');

                $('.mask_content').append('<div><br/><button class="ajax_api_btn2" onclick="ajax_test()">立即调试</button><br/></div>');
                console.log(a);
            }
        }
    });
})
function ajax_test() {
    var api_root = $('#api_root').html();
    var api_url = $('#api_url').html();
    var url = api_root+api_url;
    var method = $('#api_post').html();
    var type = $('#api_type').html();
    var code = $('#api_code').html();
    console.log(editor);
    
    var data = jQuery.parseJSON(editor.getValue());
    
    $('.mask_content').append('<div>请求中...</div>');
    $.ajax({
        type: method,
        data:data,
        url: url,
        contentType: type+";charset="+code,
        headers: {
            "api_key":"<?php echo $config['websocket_api_key'];?>",
        },
        success: function(data) {
            console.log(data);
            $('.mask_content').append('<div>请求成功...</div>');
            if (data == null || data=='' || data==undefined) {
                $('.mask_content').append('<div style="color:red">注意：接口无返回值！</div>');
            } else {
                var timestamp = Date.parse(new Date());
                $('.mask_content').append('<div>返回值：</div>');
                $('.mask_content').append('<textarea id="ajax_return_'+timestamp+'">'+JSON.stringify(eval('('+data+')'), null, 4)+'</textarea>');
                var json = {lineNumbers: true,mode: "text/javascript",styleActiveLine: true,theme: 'material',lineWrapping: true};
                CodeMirror.fromTextArea(document.getElementById("ajax_return_"+timestamp), json).setSize('85%', '100%');
            }
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            $('.mask_content').append('<div style="color:red">请求错误...</div>');
            $('.mask_content').append('<div style="color:red">状态码：'+XMLHttpRequest.status+'</div>');
            $('.mask_content').append('<div style="color:red">状态：'+XMLHttpRequest.readyState+'</div>');
            $('.mask_content').append('<div style="color:red">错误信息：'+textStatus+'</div>');
        }
    });

    
}
</script>

<?php } else { ?>
    
    <div style="width:100%;height:360px;background-color: #00b38a;"></div>
    <div style="width: 540px;height: 330px;border: 1px solid #eee;padding: 10px;position: absolute;top: 200px;left: 50%;margin-left: -270px;background: #fff;">
        <h1 style="padding: 30px 50px;"><?php echo TITLE;?></h1>
        <input type="password" id="pwd" placeholder="请输入密码" style="width: 90%;margin: 5%;border: 0;border-bottom: 1px solid #d2d2d2;padding-bottom: 15px;outline:none;font-size: 16px;">
        <button style="width: 90%;margin: 5%;height:50px;color: #fff;background-color: #00b38a;font-size: 18px;border: 0;" class="login">登陆</button>
    </div>
<?php } ?>
    </body>

</html>

<script>
<?php if (!empty($_SESSION['websocket_word'])) { ?>
    CodeMirror.fromTextArea(document.getElementById("api_c"), json).setSize('100%', '100%');
    CodeMirror.fromTextArea(document.getElementById("code_a"), json).setSize('100%', '100%');

// 代码高亮
var json = {lineNumbers: true,mode: "text/javascript",styleActiveLine: true,theme: 'material',lineWrapping: true};
<?php $num = 0;?>
<?php foreach( $api as $k=>$v) { ?>
<?php $num++;?>
CodeMirror.fromTextArea(document.getElementById("api_<?php echo $num;?>"), json).setSize('100%', '100%');
<?php } ?>
<?php $num = 0;?>
<?php foreach( $code as $k=>$v) { ?>
<?php $num++;?>
CodeMirror.fromTextArea(document.getElementById("code_<?php echo $num;?>"), json).setSize('100%', '100%');
<?php } ?>
<?php $num = 0;?>
<?php foreach( $http as $k=>$v) { ?>
<?php $num++;?>
CodeMirror.fromTextArea(document.getElementById("http_<?php echo $num;?>"), json).setSize('100%', '100%');
<?php } ?>

<?php } ?>

// 获取接口已对接完成数
var i = 0;
$('.menu-sub li a').each(function(){
    var color = $(this).css('color');
    if (color == 'rgb(3, 169, 244)') {
        i++;
    }
})
$('#ok').html(i);

// 切换接口地址
$('#tab').click(function(){
    var display=$('.hide').css('display')
    if(display=='none'){
        $('.hide').show();
    }else{
        $('.hide').hide();
    }
})

// 退出登陆
$('#out').click(function(){
    $.ajax({
        type: 'post',
        data:{},
        url: "index.php?status=out",
        success: function(data) {
            alert(data);
            window.location.reload();
        }
    });
})

// 登陆
$('.login').click(function(){
    $.ajax({
        type: 'post',
        data:{
            'pwd':$('#pwd').val()
        },
        url: "index.php?status=login",
        success: function(data) {
            if (data == 1) {
                alert('登陆成功');
                window.location.reload();
            } else {
                alert('密码错误！');
            }
        }
    });
})

</script>